
module Hierarchy
:
sig
   type t
   val node : unit -> t
   val add : t -> t -> t
   val preorder : t -> unit 
end
=
struct
   type t =
      {
      alt:t option; mutable sub:t option;
      mutable mini:int; mutable maxi:int
      }
   let node () =
      {alt=None;sub=None;mini=0;maxi=0}
   let add child p =
      p.sub <- Some {child with alt=p.sub}; p
   let rec preorder n = function
      | None -> n
      | Some t ->
         t.mini <- n;
         t.maxi <- 1 + preorder t.mini t.sub;
         preorder t.maxi t.alt
   let preorder t =
      ignore(preorder 0 (Some t))
   type result =
      | Less | Equal | More | Left | Right
   let relate ta tb = 
      if ta.maxi <= tb.mini then Left
      else if ta.mini >= tb.maxi then Right
      else if ta.mini >= tb.mini && ta.maxi < tb.maxi then Less
      else if tb.mini <= ta.mini && tb.maxi > ta.maxi then More
      else Equal
end


let my_hierarchy =
   node()
   |> add (node()
      |> add (node())
      |> add (node() |> add (node()) |> add (node()))
      )
   |> add (node() |> add (node() |> add (node())))
   |> add (node()
      |> add (node())
      |> add (node() |> add (node())))
;;
preorder my_hierarchy;;
my_hierarchy;;
