
type 'a stream = Cons of 'a * 'a stream lazy_t

let rec ones =
	Cons(1,lazy ones)
	
let rec integers i =
	Cons(i,lazy (integers (i+1)))

let rec map f = function
	Cons(h,lazy t) -> Cons(f h,lazy (map f t))

let rec unfold f i =
	Cons(i,lazy (unfold f (f i)))

let fibonacci =
	unfold (fun (a,b)->(b,a+b)) (1,1)

type pi_digits =
	{q:int;r:int;t:int;i:int;y:int}

let pi_digits =
	unfold
		(fun {q;r;t;i;_} ->
			let u = 3*(3*i+1)*(3*i+2)
			and y = (q*(27*i-12)+5*r)/(5*t)
			in {q=10*q*i*(2*i-1);r=10*u*(q*(5*i-2)+r-y*t);t=t*u;i=i+1;y})
		{q=1;r=180;t=60;i=2;y=3}

let pi_digits =
	let Cons(_,lazy t) = pi_digits
	in map (fun {y;_} -> y) t

let rec take n = function
	Cons(h,lazy t) -> if n=0 then [] else h::take (n-1) t


type 'a t =
	Fork of 'a t lazy_t * 'a * 'a t lazy_t

let rec unfold f i =
	let l,r = f i in
	Fork(lazy (unfold f l),i,lazy (unfold f r))

let paths_to_ranks =
	unfold (fun i -> i+i+0,i+i+1) 1
	